﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file LampRecognition.py
 @brief ModuleDescription
 @date $Date$
"""

import sys
import csv
import time
import traceback
import locale
sys.path.append(".")

# Import RTM module
import os
import RTC
import OpenRTM_aist
#add codes
import cv2
import numpy as np
import datetime
import Tkinter
import PyQt4.QtCore as QtCore
import PyQt4.QtGui as QtGui
import copy
import urllib
import urllib3
import requests
from pytz import timezone
from PIL import Image
#from twilio.rest import Client

#account_sid = "AC1fd3f7ceab8d4d6d68a087b18aa941d3"
#auth_token = "05168a8bc5dc82cada06562f7f0746dd"
#client = Client(account_sid, auth_token)
#client2 = Client(account_sid, auth_token)

buf = "+8XXXXXXXXXXX"

import rect_idl

sys.setrecursionlimit(1000000) # 1000000回 まで再帰呼び出しを許可

# Import Service implementation class
# <rtc-template block="service_impl">
from rect_idl_example import *

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
lamprecognition_spec = ["implementation_id", "LampRecognition", 
		 "type_name",         "LampRecognition", 
		 "description",       "ModuleDescription", 
		 "version",           "1.0.0", 
		 "vendor",            "VenderName", 
		 "category",          "Category", 
		 "activity_type",     "STATIC", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

##
# @class LampRecognition
# @brief ModuleDescription
# 
# 

#global
threshnum =[[0,0,0,0,0,0,0],[0,0,0,0,0,0,0],[0,0,0,0,0,0,0],[0,0,0,0,0,0,0]] 
window = [0,0,1000,1000]
SETFILE = "setting.csv"

usleep = lambda x: time.sleep(x/1000000.0)
"""
define global variable
"""
# caliburation parameter
calib = [[0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0]]

# Processing Image Size
imgsize = [2400,2400];

# Storing Image Size
strsize = [600,600];

img_psp=[]
img_psp2=[]
psp_matrix=[]
pImg = []
resizeImg =[]
#Keep Rect number
list_rects_num= 0
list_rects=[]
Rects =[]
opening =[]
#Image numuber sum
opening_G = []
opening_Y = []
opening_R = []

# green red yellow threshold
green_lower = []
green_upper = []

red_lower = []
red_upper = []

last_time = 0

yellow_lower = []
yellow_upper = []

fileData = ""
date_str = datetime.date.today()
#print(date_str)
# Dateの取得
datetime.datetime.now().date()

# Timeの取得
datetime.datetime.now().time()

# Timestampの取得
#datetime.datetime.now().timestamp()

# 文字列にする
time_str = datetime.datetime.now().strftime("%H:%M:%S")

#Make  Rectangle 
rect_list =[]
Rect =[]

x=[]
y=[]
w=[]
h=[]

rc=[]

#track_bar set
numb = [0, 0, 0,  128, 128, 128, 0, 0, 1000, 1000]
morph = [0]

#Rect updImg
list_rects=[]
cur_res_path =""


class LampRecognition(OpenRTM_aist.DataFlowComponentBase):
	
        def __init__(self, manager):
            OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)
            
            #self._d_rec = OpenRTM_aist.instantiateDataType(RTC.TimedShortSeq)
            self._d_rec = RTC.TimedShortSeq(RTC.Time(0,0),[])
            """
            """
            self._ResultOut = OpenRTM_aist.OutPort("Result", self._d_rec)
            """
            """
            self._RectServicePort = OpenRTM_aist.CorbaPort("RectService")

            """
            """
            self._myService = lampRect_i()

	def onInitialize(self):
            global interval, camera_id, camWidth, camHeight, extcamid

            self.addOutPort("Result",self._ResultOut)
            self._RectServicePort.registerProvider("myService", "LampRecog::lampRect", self._myService)
            self.addPort(self._RectServicePort)

            self.addOutPort("Result",self._ResultOut)
            
            self._RectServicePort.registerProvider("RectService", "LampRecog::lampRect", self._myService)
            
            self.addPort(self._RectServicePort)
            

            args = sys.argv
            interval = int(args[1])
            camera_id = int(args[2])
            camWidth = int(args[3])
            camHeight = int(args[4])
            extcamid = args[5]
            return RTC.RTC_OK

        def onActivated(self, ec_id):
            global last_time
            self.cap = cv2.VideoCapture(camera_id)
            self.last_time = 0.0
            self.cur_res_path=""
            return RTC.RTC_OK

        def onDeactivated(self, ec_id):
            cv2.destroyAllWindows()
            self.cap.release()
            return RTC.RTC_OK

        def onExecute(self, ec_id):
            global fileData,interval,extcamid
            # keyboard param	
            base_time = time.time()
            
            if ((base_time-self.last_time) > interval):
                if(self._myService.isNew() == 1):
                    print("execute ServicePort")
                    test1 = self._myService.img
                    test2 = self._myService.calib
                    test3 = self._myService.rects
                    test4 = self._myService.thresh
                    print("------Setting: read from Service Port------")
                    print(test1)
                    print(test2)
                    print(test4)
                    print(test3)
                    print("------------------end---------------------")
                    self.resetSetting()

                date_str = datetime.date.today()
               # print(date_str)
                # Dateの取得
                datetime.datetime.now().date()

                # Timeの取得
                datetime.datetime.now().time()

                # 文字列にする
                time_str = datetime.datetime.now().strftime("%H:%M:%S")
                print(time_str)

                print("interval")

                print(base_time - self.last_time)
                self.last_time = base_time            
                date_str = datetime.date.today()
                time_str = datetime.datetime.now().strftime("%H:%M:%S")

                data_cam = "data/" + extcamid;
                data_dir = "data/" + extcamid +"/" + str(date_str)
                path_im = data_dir+"/image";
                path_re = data_dir+"/result";

                if not os.path.exists(data_dir):
                        os.makedirs(data_dir)
                        os.makedirs(path_im)
                        os.makedirs(path_re)

                img_path = data_dir + "/image/" + time_str + ".jpg"
                last_res_path = self.cur_res_path;
                self.cur_res_path = data_dir + "/result/" + time_str + ".txt"

                #camera capture        
                if not self.cap.isOpened():
                    self.cap = cv2.VideoCapture(camera_id)

                capImg,psp_matrix,img_psp,img_psp2,resizeImg = self.setup(self.cap)
                print("after setup"+"\n")


                # test start loop print
                #print("start loop")
                     
                self.lampRecognition(capImg,psp_matrix,img_psp,img_psp2,resizeImg)
              #  print("test:thre hand setting"+str(threshnum))
              #  print("green_upper"+str(green_upper))
              #  print("fileData:"+str(fileData))
                # end loop print
                print("end loop")   
                   
            else:
                pass

            return RTC.RTC_OK

#Lamp area button
        def cbButton1(self):
            global list_rects,Rects
            print("SET AREA"+"\n")
            for i in range(6):
                threshnum[3][i] = numb[i]
                threshnum[3][6] = morph[0]
            list_rects =copy.deepcopy(Rects)
            print("list_rects(button):"+str(list_rects))
            print("list_rects_num(button):"+str(len(list_rects)/4))
            for i in range(4):
                window[i] = numb[i+6]
            self.cbButton()

#set green button
        def cbButton2(self):
            global list_rects,Rects
            print("SET Green"+"\n")
            for i in range(6):
                threshnum[0][i] = numb[i]
                threshnum[0][6] = morph[0]
            self.cbButton()

#set red button
        def cbButton3(self):
            print("SET RED"+"\n")
            global list_rects,Rects
            for i in range(6):
                    threshnum[1][i] = numb[i]
                    threshnum[1][6] = morph[0]
            self.cbButton()

#SET YELLOW
        def cbButton4(self):
            print("SET Yellow"+"\n")
            global list_rects,Rects
            for i in range(6):
                threshnum[2][i] = numb[i]
                threshnum[2][6] = morph[0]
            self.cbButton()

        def change(selfval):
            return val

#lect_list(lamp area) button
        def cbButton(self):
            global list_rects,Rects
            for i in range(4):
                for j in range(7):
                    sys.stdout.write(","+str(threshnum[i][j]))
                sys.stdout.write('\n')

            for i in range(4):
                sys.stdout.write(","+str(window[i]))
            sys.stdout.write('\n')

            for i in range(0,int(len(list_rects)/4)):
                sys.stdout.write("list_rect:"+str(list_rects[i*4])+","+str(list_rects[i*4+1])+","+str(list_rects[i*4+2])+","+str(list_rects[i*4+3]))
                sys.stdout.write('\n')
                sys.stdout.write("list_rect_num:"+str(int(len(Rects)/4)))

            sys.stdout.write('\n')
        """
        Define: ServicePort Reset Beheavior 
        """

        def resetSetting(self):
            global calib,camWidth,camHeight,green_lower,green_upper,red_lower,red_upper,yellow_lower,yellow_upper,list_rects,list_rects_num
            print("Reset readSetting")
            #ServicePort:getSize
            data = self._myService.getSize()
            imgsize[0] = data[0]
            imgsize[1] = data[1]

            #ServicePort:getPers
            n_pers = self._myService.getCalib()
            perspective1 = np.float32([ [n_pers[0][0], n_pers[0][1]],
                                        [n_pers[0][2], n_pers[0][3]],
                                        [n_pers[0][4], n_pers[0][5]],
                                        [n_pers[0][6], n_pers[0][7]]])
            
            perspective2 = np.float32([ [n_pers[1][0], n_pers[1][1]],
                                        [n_pers[1][2], n_pers[1][3]],
                                        [n_pers[1][4], n_pers[1][5]],
                                        [n_pers[1][6], n_pers[1][7]]])

            print("finish read perspective\n")
            #ServicePort:getThresh
            n_thresh = self._myService.getThresh()
            for i in range(4):
                for j in range(7):
                    threshnum[i][j] = n_thresh[i][j]

            #ServicePort:getRects
            n_rect = self._myService.getRects()
            #test
            print(str(n_rect))
            del list_rects[:]
            #test2
            list_num = len(n_rect)
            print(str(list_num))
            
            for i in range(0,list_num):
                for j in range(4):
                    list_rects.append(n_rects[i+14][j])
            print(str(list_rects))
            psp_matrix = cv2.getPerspectiveTransform(perspective1,perspective2)
            img_psp = cv2.warpPerspective(capImg, psp_matrix, (int(imgsize[0]),int(imgsize[1])))

            img_psp2 = cv2.warpPerspective(capImg, psp_matrix, (int(imgsize[0]),int(imgsize[1])))
            resizeImg = cv2.resize(img_psp, (int(2400),int(2400)))
            print("all parameter has been read")

            self.writeSetting()  #save new setting
            print "All settings modified"

# read setting
        def readSetting(self,cap):
            global calib,camWidth,camHeight,green_lower,green_upper,red_lower,red_upper,yellow_lower,yellow_upper,list_rects,list_rects_num
            print("Entry readSetting")
#while(True):
#capImg = tmpsetup(cap)
#   cv2.imshow("frame",capImg)
            ret = cap.set(3,camWidth) #first: size setup
            ret = cap.set(4,camHeight)
               
               #ret,capImg = cap.read()
            ret,capImg = cap.read()
#    cv2.imshow('frame', capImg)
#    if cv2.waitKey(0) == 27: # Waitkey() == 'r'
#       #break 
#        continue #fix O  

            with open('./data/0/setting.csv', 'r') as f:
                print("open csv")
                csvdata = csv.reader(f)
#string read
                data_csv = [ x for x in csvdata ]
#int convert
                data = [[int(elm) for elm in v] for v in data_csv]

#print("data:"+str(data))
                print("data[1][1]"+str(data[1][1]))
                imgsize[0] = data[0][0]
                imgsize[1] = data[0][1]

                perspective1 = np.float32([[data[1][0], data[1][1]],
                                    [data[2][0], data[2][1]],
                                    [data[3][0], data[3][1]],
                                    [data[4][0], data[4][1]]])

                perspective2 = np.float32([[data[5][0], data[5][1]],
                                        [data[6][0], data[6][1]],
                                        [data[7][0], data[7][1]],
                                        [data[8][0], data[8][1]]])
                print("finish read perspective\n")
                calib = [
                        [   data[1][0],data[1][1],
                            data[2][0],data[2][1],
                            data[3][0],data[3][1],
                            data[4][0],data[4][1]],
                        [   data[5][0],data[5][1],
                            data[6][0],data[6][1],
                            data[7][0],data[7][1],
                            data[8][0],data[8][1]]
                        ]

             #read threshold line 9 -> 12 (4 item)
                for i in range(4):
                    for j in range(7):
                        threshnum[i][j] = data[9+i][j]

#clear list_rect 
                del list_rects[:]
                list_num = data[13][0]

                list_rects = data[14]
           #     for i in range(0,list_num):
            #        for j in range(4):
             #           list_rects.append(data[i+14][j])

              #  for i in range(0,list_num*4):
               #     list_rects.append(data[i+14][j])
                    #for j in range(4):
                       # list_rects.append(data[i+14][j])
                
                psp_matrix = cv2.getPerspectiveTransform(perspective1,perspective2)
                img_psp = cv2.warpPerspective(capImg, psp_matrix, (int(imgsize[0]),int(imgsize[1])))

                img_psp2 = cv2.warpPerspective(capImg, psp_matrix, (int(imgsize[0]),int(imgsize[1])))
                resizeImg = cv2.resize(img_psp, (int(2400),int(2400)))
                print("all parameter has been read")
            return capImg,psp_matrix,img_psp,img_psp2,resizeImg

          
#csv write
        def writeSetting(self):
            path = "./data/" + extcamid + "/" +SETFILE
            #path = "./data/" +SETFILE
            setting = open(path, mode='w')
            #Image size and Perspective Matrix
            setting.write(str(imgsize[0]) +","+ str(imgsize[1])+"\n")

            setting.write(str(calib[0][0])+','+str(calib[0][1])+"\n")
            setting.write(str(calib[0][2])+','+str(calib[0][3])+"\n")
            setting.write(str(calib[0][4])+','+str(calib[0][5])+"\n")
            setting.write(str(calib[0][6])+','+str(calib[0][7])+"\n")

            setting.write(str(calib[1][0])+','+str(calib[1][1])+"\n")
            setting.write(str(calib[1][2])+','+str(calib[1][3])+"\n")
            setting.write(str(calib[1][4])+','+str(calib[1][5])+"\n")
            setting.write(str(calib[1][6])+','+str(calib[1][7])+"\n")
            setting.write(str(calib[1][6])+','+str(calib[1][7])+"\n")
            setting.write(str(int(len(list_rects)/4))+"\n")

            rects_num = int(len(list_rects)/4)

            for i in range(0,int(len(list_rects)/4)):
                if i == int(len(list_rects)/4)-1:
                    setting.write(str(list_rects[i*4])+","+str(list_rects[i*4+1])+","+str(list_rects[i*4+2])+","+str(list_rects[i*4+3])+"\n")
                else:
                    setting.write(str(list_rects[i*4])+","+str(list_rects[i*4+1])+","+str(list_rects[i*4+2])+","+str(list_rects[i*4+3])+","+"\n")
                
                

#Threshold values
            for i in range(0,4):
                for j in range(0,7):
                    if j==6:
                        setting.write(str(threshnum[i][j])+"\n")
                    else:
                        setting.write(str(threshnum[i][j])+",")
#Threshold values
           # for i in range(0,4):
           #     for j in range(0,7):
           #         if j==6:
           #             setting.write(str(threshnum[i][j])+"\n")
           #         else:
           #             setting.write(str(threshnum[i][j])+",")

            #Lamp Areas
           # rects_num = int(len(list_rects)/4)
           # setting.write(str(rects_num)+"\n")
#write rectangles
           # for i in range(0,rects_num):
           #     if i == rects_num-1:
           #         setting.write(str(list_rects[i*4])+","+str(list_rects[i*4+1])+","+str(list_rects[i*4+2])+","+str(list_rects[i*4+3])+"\n")
           #     else:
           #         setting.write(str(list_rects[i*4])+","+str(list_rects[i*4+1])+","+str(list_rects[i*4+2])+","+str(list_rects[i*4+3])+","+"\n")

            setting.close()
#setup 
#Ohtani: fixed indent tab=8
        def setup(self,cap):
            # if inifile no
            global imgsize,capImg,pImg,psp_matrix,psp_matrix2,img_psp,img_psp2,resizeImg,calib,numb


            #path = "./data/" + extcamid + "/" +SETFILE
            path = "./data/0/setting.csv"

            if os.path.isfile(path): 
                #print("Using previous setting? (Y/N) [Y]: ")
                #yes= raw_input()
                #if yes =="yes":
                capImg,psp_matrix,img_psp,img_psp2,resizeImg = self.readSetting(cap)
                return capImg,psp_matrix,img_psp,img_psp2,resizeImg
            print("####################################")
            print("### Phase 1: Camera Calibulation ###")
            print("####################################")
            
            print("One the Caputured Image, Press [r] key: Reload Image, Press [d] keys: Next Process")

#check p.1
            while(True):
                ret = cap.set(3,camWidth) #first: size setup
                ret = cap.set(4,camHeight)
                
                #ret,capImg = cap.read()
                ret,capImg = cap.read() # *vc >> capImg 
                cv2.imshow('frame', capImg)
                if cv2.waitKey(0) == 27: # Waitkey() == 'r'
                    #break 
                    continue
          
                #label .pespective
                print("Phase 1: Find Perspective Transform Matrix")
                print("cameracaliblation\n")
                print("Image Size??:\n")               

                #if key == ord('d'):
                print("input:w/n")
                imgsize[0] = input()
                print("input:h/n")
                imgsize[1]= input()

                print("Input 4 Points for Input Image. \n")
                print("x0:")
                calib[0][0] = input()
                print("y0:")
                calib[0][1] = input()
                print("x1:")
                calib[0][2] = input()
                print("y1:")
                calib[0][3] = input()
                print("x2:")
                calib[0][4] = input()
                print("y2:")
                calib[0][5] = input()
                print("x3:")
                calib[0][6] = input()
                print("y3:")
                calib[0][7] = input()
                
                print("second 4 point")

                print("xx0:\n")
                calib[1][0] = input()
                print("yy0:\n")
                calib[1][1] = input()
                print("xx1:\n")
                calib[1][2] = input()
                print("yy1:\n")
                calib[1][3] = input()
                print("xx2:\n")
                calib[1][4] = input()
                print("yy2:\n")
                calib[1][5] = input()
                print(type(calib[1][5]))
                print("xx3:\n")
                calib[1][6] = input()
                print("yy3:\n")
                calib[1][7] = input()
                
                perspective1 = np.float32([[calib[0][0], calib[0][1]],
                                        [calib[0][2], calib[0][3]],
                                        [calib[0][4], calib[0][5]],
                                        [calib[0][6], calib[0][7]]])

                perspective2 = np.float32([[calib[1][0], calib[1][1]],
                                        [calib[1][2], calib[1][3]],
                                        [calib[1][4], calib[1][5]],
                                        [calib[1][6], calib[1][7]]])
                # get Transformation Matrix
                psp_matrix = cv2.getPerspectiveTransform(perspective1,perspective2)

                img_psp = cv2.warpPerspective(capImg, psp_matrix, (int(imgsize[0]),int(imgsize[1])))
                #print("calib:"+type(calib[0][1]))
                #print("capImg test"+str(capImg)) # aru
                #print("img_psp:"+str(img_psp))#aru
                cv2.imshow('secondImage', img_psp)


                print("reload Image d")
                if cv2.waitKey() == ord('d'):
                    continue # goto perspective
                # else if cv2.waitKey() == ord('r') -> continue

                cv2.destroyAllWindows()
                break
           
            print("####################################")
            print("###  Phase 2: Threshold Setting  ###")
            print("####################################")

            print("One the Caputured Image, Press [r] key: Reload Image, Press [d] keys: Next Process")
          
            cv2.namedWindow("Filter")
            cv2.createTrackbar('low_Y','Filter',numb[0],255,self.upd1)
            cv2.createTrackbar('low_R','Filter',numb[1],255,self.upd2)
            cv2.createTrackbar('low_B','Filter',numb[2],255,self.upd3)
            cv2.createTrackbar('High_Y','Filter',numb[3],255,self.upd4)
            cv2.createTrackbar('High_R','Filter',numb[4],255,self.upd5)
            cv2.createTrackbar('High_B','Filter',numb[5],255,self.upd6)
            cv2.createTrackbar('low_W','Filter',numb[6],1000,self.upd7)
            cv2.createTrackbar('low_H','Filter',numb[7],1000,self.upd8)
            cv2.createTrackbar('Hig_W','Filter',numb[8],1000,self.upd9)
            cv2.createTrackbar('Hig_H','Filter',numb[9],1000,self.upd10)
            cv2.createTrackbar('morph','Filter',morph[0],1000,self.changemorph)
            
            app = QtGui.QApplication(sys.argv)
            
            main_window1 = QtGui.QMainWindow()
            main_window2 = QtGui.QMainWindow()
            main_window3 = QtGui.QMainWindow()
            main_window4 = QtGui.QMainWindow()
            #
            setArea = QtGui.QPushButton("set Area")
            setGreen = QtGui.QPushButton("set Green ")
            setYellow = QtGui.QPushButton("set Yellow")
            setRed = QtGui.QPushButton("set Red")

            setArea.clicked.connect(self.cbButton1)
            setGreen.clicked.connect(self.cbButton2)
            setRed.clicked.connect(self.cbButton3)
            setYellow.clicked.connect(self.cbButton4)

            main_window1.setCentralWidget(setArea)
            main_window2.setCentralWidget(setGreen)
            main_window3.setCentralWidget(setYellow)
            main_window4.setCentralWidget(setRed)

            main_window1.show()
            main_window2.show()
            main_window3.show()
            main_window4.show()
            
            #main_win = tkinter.Tk() #create window
            #main_win.title("Set Button") 
            #main_win.geometry("300x300") #window size(pixel)
            
            #setArea = tkinter.Button(main_win, text="SetArea", height=2, width=5,command=cbButton1)
            #setArea.pack() # window.show()

            #setGreen = tkinter.Button(main_win, text="SetGreen", height=2, width=5,command=cbButton2)
            #setGreen.pack() # window.show()
            
            #setYellow = tkinter.Button(main_win, text="SetYellow", height=2, width=5,command=cbButton3)
            #setYellow.pack() # window.show()

            #setRed = tkinter.Button(main_win, text="SetRed", height=2, width=5,command=cbButton4)
            #setRed.pack() # window.show()


            while(True):
                print("entry light view")
                ret = cap.set(3,camWidth) #first: size setup
                ret = cap.set(4,camHeight)

                ret,capImg = cap.read()
                img_psp2 = cv2.warpPerspective(capImg, psp_matrix, (int(imgsize[0]), int(imgsize[1]))) 
                
                #print(img_psp2)
                resizeImg = cv2.resize(img_psp2, (600,600)) #dst resize
                
                # light view
                
                cv2.imshow("light view",resizeImg)
                if cv2.waitKey() == ord('r'):
                    continue
                #resizing Img
                #pImg = cv2.cvtColor(img_psp2, cv2.COLOR_BGR2YCrCb)
                pImg = cv2.cvtColor(img_psp2, 36L)
                #pImg = cv2.cvtColor(img_psp2, cv2.COLOR_BGR2RGB)
                if cv2.waitKey() == ord('r'):
                    continue

                cv2.imshow("Filter",resizeImg)
                
                ret,capImg = cap.read()

                print("after truckbar")
                if cv2.waitKey() == ord('q'):
                 #  cap.release()
                    cv2.destroyAllWindows()
                    #main_win.quit()
                    print("setup finish")
                    break

            self.writeSetting()

            print("return"+'/n')
            # need not Img_psp2
            return capImg,psp_matrix,img_psp,img_psp2,resizeImg


        def updImg(self):
           
            global list_rects,Rects
            
            #Rects.clear()
            Rects = [] 
            element = np.ones((morph[0],morph[0]),np.uint8)
            #// inverse lamp 
            if numb[0] >= numb[3]:
                numb[3] = numb[0]+1
            if numb[1] >= numb[4]:
                numb[4] = numb[4]+1
            if numb[2] >= numb[5]:
                numb[5] = numb[2]+1
            if numb[6] >= numb[8]:
                numb[8] = numb[6]+1
            if numb[7] >= numb[9]:
                numb[9] = numb[7]+1


            #updImg settin upper lower
            lower = np.array([numb[0],numb[1],numb[2]])
            upper = np.array([numb[3],numb[4],numb[5]])
            

            Img_Filt = cv2.inRange(pImg, lower, upper)
            copy_Img = Img_Filt.copy()
            print("numb"+str(numb[0]))
            print("numb"+str(numb[1]))
            print("numb"+str(numb[2]))
            print("numb"+str(numb[3]))
            print("numb"+str(numb[4]))
            print("numb"+str(numb[5]))
            #closing = cv2.morphologyEx(Img_Filt, cv2.MORPH_CLOSE,element)
            #opening = cv2.morphologyEx(closing, cv2.MORPH_OPEN,element)
            cv2.morphologyEx(Img_Filt, cv2.MORPH_CLOSE,element)
            cv2.morphologyEx(Img_Filt, cv2.MORPH_OPEN,element)

           # cv2.imshow("Img_Filt",Img_Filt)

            #dst,contours,hierarchy = cv2.findContours(opening, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)
            dst,contours,hierarchy = cv2.findContours(Img_Filt, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)
            #hierarchy = cv2.findContours(Img_Filt, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)

            for i in range(0, len(contours)):
                if len(contours[i]) > 0:
                    rect = contours[i]
                    for hierarchys in enumerate(hierarchy):
                        x,y,w,h = cv2.boundingRect(rect)
                        if h > numb[7] and h < numb[9] and w > numb[6] and w < numb[8]:
                            Rects.append(x)
                            Rects.append(y)
                            Rects.append(w)
                            Rects.append(h)

            for i in range(0,int(len(Rects)/4)):
                    #cv2.rectangle(opening,(Rects[4*i],Rects[4*i+1]),(Rects[4*i]+Rects[4*i+2],Rects[4*i+1]+Rects[4*i+3]),(128,255,128),cv2.FILLED)
                    cv2.rectangle(Img_Filt,(Rects[4*i],Rects[4*i+1]),(Rects[4*i]+Rects[4*i+2],Rects[4*i+1]+Rects[4*i+3]),(128,255,128),cv2.FILLED)
            resizeImg2 = cv2.resize(Img_Filt, (600,600))
            print("Rects:"+str(Rects)) #list_rects number 
            rects = copy.copy(Rects)
            #print("list_rects:"+str(list_rects))
            print("\n")
            #print("length"+str(len(list_rects)))
            print("length_num"+str(len(list_rects)/4)) #keep
            cv2.imshow("Filter", resizeImg2)

         
                        

#button setting
        def upd1(self,val1):
            global numb
            numb[0] = val1
            self.updImg()

        def upd2(self,val2):
            global numb
            numb[1] = val2
            self.updImg()

        def upd3(self,val3):
            global numb
            numb[2] = val3
            self.updImg()

        def upd4(self,val4):
            global numb
            numb[3] = val4
            self.updImg()

        def upd5(self,val5):
            global numb
            numb[4] = val5
            self.updImg()

        def upd6(self,val6):
            global numb
            numb[5] = val6
            self.updImg()

        def upd7(self,val7):
            global numb
            numb[6] = val7
            self.updImg()

        def upd8(self,val8):
            global numb
            numb[7] = val8
            self.updImg()

        def upd9(self,val9):
            global numb
            numb[8] = val9
            self.updImg()

        def upd10(self,val10):
            global numb
            numb[9] = val10
            self.updImg()

        def changemorph(self,val):
            global morph 
            morph[0] = val
            self.updImg()


        def lampRecognition(self,capImg,psp_matrix,img_psp,img_psp2,resizeImg):
            # test global variable
            global threshnum,green_lower,green_upper,red_lower,red_upper,yellow_lower,yellow_upper,perspective1,perspective2,calib,list_rects,fileData
            
            ret,capImg = self.cap.read()

            #declare directory char
            data_cam = "data/" + extcamid
            data_dir = "data/" + extcamid +"/" + str(date_str)
            path_im = data_dir+"/image"
            path_re = data_dir+"/result"
            time_str = datetime.datetime.now().strftime("%H:%M:%S")
            img_path = data_dir + "/image/" + time_str + ".jpg"
            file_path = data_dir + "/result/" + time_str + ".txt"
            
            # make perspextive  update Image ##################### 
            perspective1 = np.float32([[calib[0][0], calib[0][1]],
                                    [calib[0][2], calib[0][3]],
                                    [calib[0][4], calib[0][5]],
                                    [calib[0][6], calib[0][7]]])

            perspective2 = np.float32([[calib[1][0], calib[1][1]],
                                    [calib[1][2], calib[1][3]],
                                    [calib[1][4], calib[1][5]],
                                    [calib[1][6], calib[1][7]]])
            # get Transformation Matrix
            psp_matrix = cv2.getPerspectiveTransform(perspective1,perspective2)

            img_psp = cv2.warpPerspective(capImg, psp_matrix, (int(imgsize[0]), int(imgsize[1])))

            #pImg = cv2.cvtColor(img_psp, cv2.COLOR_BGR2YCrCb)
            pImg = cv2.cvtColor(img_psp, 36L)

            # make dir 
            if not os.path.exists(data_dir):
                    os.makedirs(data_dir)
            if not os.path.exists(path_im):
                    os.makedirs(path_im)
            if not os.path.exists(path_re):
                    os.makedirs(path_re)

            # Write lecognition Image 
            cv2.imwrite(img_path,img_psp)

            # test print
            print("write")
            print("list_rects"+str(list_rects))

            #setting kernel
            element = np.ones((morph[0],morph[0]),np.uint8)

            #green theshold
            green_lower = np.array([threshnum[0][0], threshnum[0][1], threshnum[0][2]])
            green_upper =  np.array([threshnum[0][3], threshnum[0][4], threshnum[0][5]])
            #print("green_lower"+green_lower)
            # green opening closing
            Masked_G = cv2.inRange(pImg, green_lower, green_upper)
            closing_G = cv2.morphologyEx(Masked_G, cv2.MORPH_CLOSE,element)
            opening_G = cv2.morphologyEx(closing_G, cv2.MORPH_OPEN,element)
         
            # red threshold
            red_lower = np.array([threshnum[1][0], threshnum[1][1], threshnum[1][2]])
            red_upper =  np.array([threshnum[1][3], threshnum[1][4], threshnum[1][5]])
            
            # red opening closing
            Masked_R = cv2.inRange(pImg, red_lower, red_upper)
            closing_R = cv2.morphologyEx(Masked_R, cv2.MORPH_CLOSE,element)
            opening_R = cv2.morphologyEx(closing_R, cv2.MORPH_OPEN,element)
        
            
            #yellow threshold setting
            yellow_lower = np.array([threshnum[2][0], threshnum[2][1], threshnum[2][2]])
            yellow_upper =  np.array([threshnum[2][3], threshnum[2][4], threshnum[2][5]])

            #yellow closing opening
            Masked_Y = cv2.inRange(pImg, yellow_lower, yellow_upper)
            closing_Y = cv2.morphologyEx(Masked_Y, cv2.MORPH_CLOSE,element)
            opening_Y = cv2.morphologyEx(closing_Y, cv2.MORPH_OPEN,element)

            #write setting lamp setting
            f = open(file_path ,'w')
           
            #result: Short Array 
            result = []

            for i  in range(0,int(len(list_rects)/4)):
                # Extract Rectangle Position
                x1=list_rects[i*4]
                x2=list_rects[i*4] + list_rects[i*4+2]
                y1=list_rects[i*4+1]
                y2=list_rects[i*4+1] + list_rects[i*4+3]

                # count Image color            
                gcount = np.sum(opening_G[y1:y2,x1:x2])/255.0
                rcount = np.sum(opening_R[y1:y2,x1:x2])/255.0
                ycount = np.sum(opening_Y[y1:y2,x1:x2])/255.0
              
                #judge color
                if gcount >= rcount and gcount >= ycount and gcount >= 30:
                        lamp_color = 1
                        print("gcount test: "+str(gcount)+":"+str(lamp_color))
                        print("judgement:green")
                elif rcount > gcount and rcount >= ycount and rcount >= 30:
                        lamp_color = 2
                        print("rcount test: "+str(rcount)+":"+str(lamp_color))
                        print("judgement:Red")
                elif ycount > gcount and ycount > rcount and ycount >= 30:
                        lamp_color = 3
                        print("judgement:Yellow")
                        print("ycount test: "+str(ycount)+":"+str(lamp_color))
                else:
                        lamp_color = 0
                        print("else"+str(lamp_color))
                #print("finall_lampcolor:"+str(lamp_color))
                f.write(str(i+1)+" " +str(lamp_color)+" "+str(x1)+" "+str(y1)+"\n")
             #   fileData = "test"+"\n"

                result.append(i+1)
                result.append(lamp_color)
                result.append(x1)
                result.append(y1)
              #  print("result:"+str(result))

            f.close()
            print("result after:"+str(result))
            self._d_rec.data = result
            self._ResultOut.write()


def LampRecognitionInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=lamprecognition_spec)
    manager.registerFactory(profile,
                            LampRecognition,
                            OpenRTM_aist.Delete)

def MyModuleInit(manager):
    LampRecognitionInit(manager)

    # Create a component
    comp = manager.createComponent("LampRecognition")

def main():
        mgr = OpenRTM_aist.Manager.init(sys.argv)
        mgr.setModuleInitProc(MyModuleInit)
        mgr.activateManager()
        mgr.runManager()

if __name__ == "__main__":
        main()

