﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-

"""
 @file rect_idl_examplefile.py
 @brief Python example implementations generated from rect.idl
 @date $Date$


"""

import omniORB
from omniORB import CORBA, PortableServer
import LampRecog, LampRecog__POA
import copy


class lampRect_i (LampRecog__POA.lampRect):
    """
    @class lampRect_i
    Example class implementing IDL interface LampRecog.lampRect
    """

    def __init__(self):
        """
        @brief standard constructor
        Initialise member variables here
        """
        self.Flag = 0 #nothing new Setting
        self.rects = []
        self.thresh = []
        self.img = []
        self.calib = []
        pass

    # short setPerspect(in FloatList n_pers)
    def setParameter(self, n_img, n_calib, n_thresh, n_rects):
        self.Flag = 1 # new setting
        self.img = copy.deepcopy(n_img)
        self.calib = copy.deepcopy(n_calib)
        self.thresh = copy.deepcopy(n_thresh)
        self.rect = copy.deepcopy(n_rects)

    def getSize(self):
        return self.img

    def getCalib(self):
        return self.calib

    def getThresh(self):
        return self.thresh

    def getRects(self):
        return self.rects
    
    def isNew(self):
        return self.Flag


if __name__ == "__main__":
    import sys
    
    # Initialise the ORB
    orb = CORBA.ORB_init(sys.argv)
    
    # As an example, we activate an object in the Root POA
    poa = orb.resolve_initial_references("RootPOA")

    # Create an instance of a servant class
    servant = lampRect_i()

    # Activate it in the Root POA
    poa.activate_object(servant)

    # Get the object reference to the object
    objref = servant._this()
    
    # Print a stringified IOR for it
    print orb.object_to_string(objref)

    # Activate the Root POA's manager
    poa._get_the_POAManager().activate()

    # Run the ORB, blocking this thread
    orb.run()

